local string, type, tostring, pairs, table = 
string, type, tostring, pairs, table
module('nsg')

local function prompt(pr)
  if pr then
    return "\n"..string.rep(' ', pr)
  else
    return ""
  end
end
local function incPr(pr)
  if pr then pr = pr + 2 end
  return pr
end
local function decPr(pr)
  if pr then pr = pr - 2 end
  return pr
end

function serialize(o, pr, saved)
  local forgen = pr and pairsByKeys or pairs
  local t = type(o)
  if t == "number" then
    return tostring(o)
  elseif t == "string" then
    return string.format("%q", o)
  elseif t == "table" then
    saved = saved or {}
    if saved[o] then
      return tostring(o)
    else
      saved[o] = true
    end
    pr = incPr(pr)
    local result = "{"..prompt(pr)
    local nextIndex = 1
    local first = true
    for k, v in forgen(o, compareObject) do
      if first then
        first = false
      else
        result = result .. ","..prompt(pr)
      end
      if not pr and type(k) == "number" and k == nextIndex then
        nextIndex = nextIndex + 1
      else
        if type(k) == "string" and string.find(k, "^[_%a][_%w]*$") then
          result = result .. k
        else
          result = result .. "[" .. serialize(k, pr, saved) .. "]"
        end
        result = result .. (pr and " = " or '=')
      end
      result = result .. serialize(v, pr, saved)
    end
    pr = decPr(pr)
    result = result ..prompt(pr).."}"
    return result
  else
    return tostring(o)
  end
end

function pairsByKeys(t, f)
  local a = {}
  for n in pairs(t) do a[#a + 1] = n end
  table.sort(a, f)
  local i = 0
  return function()
    i = i + 1
    return a[i], t[a[i]]
  end
end

function compareObject(a,b) 
  local typeA = type(a)
  local typeB = type(b)
  if typeA == typeB then
    if typeA == "number" or typeA == "string" then
      return a < b
    else
      return false
    end
  end
  local t = {
    ["nil"] = 1,
    boolean = 2,
    number = 3,
    string = 4,
    table = 5,
    ["function"] = 6,
    thread = 7,
    userdata = 8,
  }
  return (t[typeA] or 10) < (t[typeB] or 10)
end
