<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" >
<xsl:output
        media-type="text/html"
        method="html"
        version="4.01"
        encoding="UTF-8"
        omit-xml-declaration="yes"
        standalone="no"
        indent="yes"
        doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN"
    />
  <xsl:template match="/ROOT">
    <html>
      <meta http-equiv="X-UA-Compatible" content="IE=7" />
      <link rel="stylesheet" type="text/css" href="/style.css"/>
      <link rel="icon" type="image/x-icon" href="/nsg.ico"/>
      <link rel="shortcut icon" type="image/x-icon" href="/nsg.ico"/>
      <script src="/jquery.js" type="text/javascript"/>
      <script src="/nsghelp.js" type="text/javascript"/>
      <script src="/boxover.js" type="text/javascript"/>
      <script src="/webtty.js" type="text/javascript"/>
      <head>
        <title><xsl:value-of select="head/title" /></title>
      </head>
      <body>
        <div id="initscript" class="initscript">
          <xsl:value-of select="head/initScript"/>
        </div>
        <div style="position:static;">
          <div id="opaco" class="hidden">
          </div>
          <div id="popup" class="hidden">
          </div>
        </div>
        <script src="/script.js" type="text/javascript"/>
        <div class="welcome">
          <img class="activityoff" alt="0" src="/loading.gif" title="header=[webJobs] body=[1]"/>
          <xsl:value-of select="head/welcome"/><xsl:text> </xsl:text><span class="welcome" onclick="showLeakChecker();"><xsl:value-of select="head/release"/></span><xsl:text>, </xsl:text><xsl:value-of select="head/mach"/>
        </div>
        <xsl:if test="head/sessionMessage">
          <ul>
            <li class="cl">
              <table class="node" title="header=[webBtnExpand] body=[]">
                <tbody>
                  <tr valign="middle">
                    <td>
                      <img class="bexpand" onkeydown="return btnKeyDown(event,this);" tabindex="0" alt="Expand" src="/nil.png" onclick="UnHide(this); return false;" title="header=[webBtnExpand] body=[]" />
                      <img class="bcollapse" onkeydown="return btnKeyDown(event,this);" tabindex="0" alt="Collapse" src="/nil.png" onclick="UnHide(this); return false;" title="header=[webBtnCollapse] body=[]" />
                    </td>
                    <td>
                      <a class="message" onkeydown="return btnKeyDown(event,this);" onclick="UnHide(this); return false;">
                        <xsl:text>Message:</xsl:text>
                        <span class="messagehead"><xsl:value-of select="substring(head/sessionMessage,1,40)"/><xsl:text>...</xsl:text></span>
                      </a>
                    </td>
                  </tr>
                </tbody>
              </table>
              <div class="dir">
                <pre ondblclick="UnHide(this);"><xsl:value-of select="head/sessionMessage"/></pre>
              </div>
            </li>
          </ul>
        </xsl:if>
        <ul>
          <li name="root" class="root">
            <table class="node" width="100%">
              <tbody>
                <tr>
                  <td class="param">
                    <xsl:value-of select="head/hostName"/>
                    <xsl:text>:</xsl:text>
                    <xsl:value-of select="head/login"/>
                    <xsl:text>(</xsl:text>
                    <xsl:value-of select="head/sessionNumber"/>
                    <xsl:text>)</xsl:text>
                  </td>
                  <td>
                    <select class="locale" onchange="setLocale(this);" style="visibility: visible;">
                      <option value="ru">
                        <xsl:if test="head/locale='ru'">
                          <xsl:attribute name="selected"></xsl:attribute>
                        </xsl:if>
                        <xsl:text>ru</xsl:text>
                      </option>
                      <option value="en">
                        <xsl:if test="head/locale='en'">
                          <xsl:attribute name="selected"></xsl:attribute>
                        </xsl:if>
                        <xsl:text>en</xsl:text>
                      </option>
                    </select>
                  </td>
                  <td>
                    <img class="blogout" onclick="logOut(); return false;" title="header=[webBtnLogout] body=[]" alt="Logout" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
                  </td>
                  <td class="usage" width="90%">
                    <a title="header=[webBtnUsage] body=[]" onclick="getUsage(this);return false;" onkeydown="return btnKeyDown(event,this);" tabindex="0">
                      <xsl:value-of select="head/usage"/>
                      <img class="brefresh" src="/nil.png" tabindex="0" alt="refresh"/>
                    </a>
                  </td>
                </tr>
              </tbody>
            </table>
            <div class="dir">
              <xsl:for-each select="parameter">
                <xsl:call-template name="DIR"/>
              </xsl:for-each>
            </div>
          </li>
        </ul>
        <div id="scriptexecutionarea" class="scriptexecutionarea"></div>
      </body>
    </html>
  </xsl:template>


  <xsl:template match="/EDITCONF">
    <xsl:for-each select="conf">
      <div class="dircontrol">
        <img class="beditsave" title="header=[webBtnEditSave] body=[]" onclick="return saveEditCfg(this);" alt="Save" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
        <img class="bvalidate" title="header=[webBtnValidate] body=[]" onclick="return validateCfg(this);" alt="Validate" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
        <img class="bedit" title="header=[webBtnUndo] body=[]" onclick="return Edit(this);" alt="Edit" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
      </div>
      <ul>
        <textarea class="edit" wrap="off" cols="80">
          <xsl:attribute name="rows">
            <xsl:if test="((string-length(.) - string-length(translate(.,'&#10;',''))) &lt; 10)">10</xsl:if>
            <xsl:if test="((string-length(.) - string-length(translate(.,'&#10;',''))) &gt; 9) and ((string-length(.) - string-length(translate(.,'&#10;',''))) &lt; 26)"><xsl:value-of select="(string-length(.) - string-length(translate(.,'&#10;','')))"/></xsl:if>
            <xsl:if test="((string-length(.) - string-length(translate(.,'&#10;',''))) &gt; 25)">25</xsl:if>
          </xsl:attribute>
          <xsl:value-of select="."/>
        </textarea>
      </ul>
    </xsl:for-each>
  </xsl:template>

  <xsl:template match="/CONF">
    <xsl:call-template name="DIR"/>
  </xsl:template>

  <xsl:template match="/ITEM">
    <xsl:call-template name="PARAMETER"/>
  </xsl:template>

  <xsl:template match="/POPUP">
    <xsl:for-each select="head">
<center><b>
      <xsl:value-of select="."/>
    </b>
      </center>
    </xsl:for-each>
    <xsl:for-each select="body">
      <xsl:value-of select="."/>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="SCRIPT">
    <xsl:for-each select="script">
      <span class="hiddenscript">
        <textarea class="hiddentext"><xsl:value-of select="."/></textarea>
      </span>
    </xsl:for-each>
  </xsl:template >
  <xsl:template name="TEXT">
    <xsl:for-each select="text">
      <span class="hiddentext">
        <textarea class="hiddentext"><xsl:value-of select="."/></textarea>
      </span>
    </xsl:for-each>
  </xsl:template >

  <xsl:template match="/NSG">
    <xsl:call-template name="TEXT"/>
    <xsl:call-template name="SCRIPT"/>
  </xsl:template>

  <xsl:template match="/EDIT">
    <xsl:for-each select="text">
      <div class="dircontrol">
        <img class="beditsave" title="header=[webBtnEditSave] body=[]" onclick="return saveEditCfg(this);" alt="Save" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);" />
        <img class="bvalidate" title="header=[webBtnValidate] body=[]" onclick="return validateCfg(this);" alt="Validate" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);" />
        <img class="bedit" title="header=[webBtnUndo] body=[]" onclick="return Edit(this);" alt="Edit" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);" />
      </div>
      <ul>
        <textarea class="edit" wrap="off" cols="80"><xsl:attribute name="rows">
          <xsl:if test="((string-length(.) - string-length(translate(.,'&#10;',''))) &lt; 10)">10</xsl:if>
          <xsl:if test="((string-length(.) - string-length(translate(.,'&#10;',''))) &gt; 9) and ((string-length(.) - string-length(translate(.,'&#10;',''))) &lt; 26)"><xsl:value-of select="(string-length(.) - string-length(translate(.,'&#10;','')))"/></xsl:if>
          <xsl:if test="((string-length(.) - string-length(translate(.,'&#10;',''))) &gt; 25)">25</xsl:if>
        </xsl:attribute><xsl:value-of select="."/></textarea>
      </ul>
    </xsl:for-each>
    <xsl:for-each select="script">
      <span class="hiddenscript">
        <textarea class="hiddentext"><xsl:value-of select="."/></textarea>
      </span>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="DIR">
    <xsl:if test="type='directory' and not(executable)">
      <xsl:if test="not(loaded='no')">
        <div class="dircontrol">
          <xsl:if test="path='{}'">
            <img class="bmanual" title="header=[webBtnManual] body=[]" onclick="return getManual(this);" alt="Man" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
          </xsl:if>
          <xsl:if test="dependence">
            <img class="bkey" title="header=[webBtnKey] body=[]" alt="!" src="/nil.png"/>
          </xsl:if>
          <img class="bedit" title="header=[webBtnEdit] body=[]" onclick="return Edit(this);" alt="Edit" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
          <xsl:if test="path='{}'">
            <img class="brefresh" title="header=[webBtnRefresh] body=[]" onclick="return loadDir(this);" alt="Refresh" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
          </xsl:if>
          <xsl:if test="plus">
            <img id="root.tunnel.gre" class="bnew" onclick="return newItem(this,getHelp('webDlgAddName'),'newKey');" title="header=[webBtnPlus] body=[]" alt="New" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);">
              <xsl:attribute name="onclick">
                return newItem(this,getHelp('<xsl:value-of select="plusHelp"/>'),'<xsl:value-of select="plus"/>Key');
              </xsl:attribute>
            </img>
          </xsl:if>
          <xsl:if test="apply">
            <img class="bapply" title="header=[webBtnApply] body=[]" onclick="applyCfg(this); return false;" alt="Apply" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
          </xsl:if>
          <xsl:if test="path='{}'">
            <img class="bsave" title="header=[webBtnSave] body=[]" onclick="return saveCfg(this);" alt="Save" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
          </xsl:if>
          <img class="bclear" onclick="return clearDir(this);" title="header=[webBtnClearDir] body=[]" alt="Clear" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
        </div>
        <ul>
          <xsl:for-each select="parameter">
            <xsl:sort  data-type="number" select="prio"/>
            <xsl:call-template name="PARAMETER"/>
          </xsl:for-each>
        </ul>
      </xsl:if>
      <xsl:if test="loaded='no'">
        <ul>
          <input class="pleasewait" type="hidden"/>
        </ul>
      </xsl:if>
    </xsl:if>
    <xsl:if test="loaded='no' and executable">
      <div class="dircontrol"> </div>
      <ul>
        <input class="runfirst" type="hidden" />
      </ul>
    </xsl:if>
  </xsl:template>

  <xsl:template name="PARAMETER">
    <xsl:call-template name="SCRIPT"/>
    <li>
      <xsl:attribute name="name"><xsl:value-of select="luaName"/></xsl:attribute>
      <xsl:attribute name="class"><xsl:value-of select="class"/></xsl:attribute>
      <table class="node">
        <tbody>
          <tr valign="middle">
            <td>
              <xsl:if test="type='directory' or executable">
                <img class="bexpand" onclick="UnHide(this); return false;" title="header=[webBtnExpand] body=[]" src="/nil.png" alt="E.innerHTML = xpand" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
                <img class="bcollapse" onclick="UnHide(this); return false;" title="header=[webBtnCollapse] body=[]" src="/nil.png" alt="Collapse" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
              </xsl:if>
            </td>
            <td class="param">
              <xsl:attribute name="title">
                <xsl:text>header=[</xsl:text><xsl:value-of select="help"/><xsl:text>] body=[</xsl:text>
                <xsl:if test="description">
                  <xsl:value-of select="description"/>
                </xsl:if>
                <xsl:text>]</xsl:text>
              </xsl:attribute>
              <xsl:if test="not(type='directory')">
                <xsl:if test="dependence">
                  <img class="bkey" title="header=[webBtnKey] body=[]" alt="!" src="/nil.png"/>
                </xsl:if>
              </xsl:if>
              <xsl:if test="type='directory'">
                <span class="dir">
                  <xsl:if test="executable">
                    <xsl:attribute name="class">exec</xsl:attribute>
                  </xsl:if>
                  <a class="name" onclick=" UnHide(this); return false;" onkeydown="paramKeyDown(event, this)" href="javascript:void(0)">
                    <xsl:value-of select="name"/>
                  </a>
                </span>
                <input class="value" type="hidden">
                  <xsl:attribute name="value"><xsl:value-of select="name"/></xsl:attribute>
                  <xsl:attribute name="name"><xsl:value-of select="name"/></xsl:attribute>
                </input>
                <input class="stype" type="hidden" value="dir"/>
                <input class="conf" type="hidden">
                  <xsl:attribute name="value"><xsl:value-of select="value"/></xsl:attribute>
                </input>
              </xsl:if>
              <xsl:if test="not(type='directory')">
                <xsl:if test="not(executable)">
                  <span class="parm">
                    <a class="name" onclick="return false;" onkeydown="paramKeyDown(event, this)" href="javascript:void(0)">
                      <xsl:value-of select="name"/>
                    </a>
                  </span>
                </xsl:if>
                <xsl:if test="executable">
                  <span class="exec">
                    <a class="name" onclick="UnHide(this);return false;" onkeydown="paramKeyDown(event, this)" href="javascript:void(0)">
                      <xsl:value-of select="name"/>
                    </a>
                  </span>
                </xsl:if>
              </xsl:if>
              <img class="bmanual" title="header=[webBtnManual] body=[]" onclick="return getManual(this);" alt="Man" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);"/>
              <xsl:if test="html">
                <img class="bhtml" title="header=[webBtnHTML] body=[]" alt="Html" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);">
                  <xsl:attribute name="onclick">return getHTML(this,'<xsl:value-of select="html"/>');</xsl:attribute>
                </img>
              </xsl:if>
            </td>
            <td class="value">
              <xsl:if test="type='directory'">
                <xsl:if test="dependence or plus">
                  <input class="dep" type="hidden" ><xsl:attribute name="value">
                    <xsl:if test="dependence"><xsl:value-of select="dependence"/></xsl:if>
                    <xsl:if test="not(dependence)">1</xsl:if>
                  </xsl:attribute>
                  </input>
                </xsl:if>
              </xsl:if>

              <xsl:if test="not(type='directory')">
                <span>
                  <xsl:if test="configured">
                    <xsl:attribute name="class">normal</xsl:attribute>
                  </xsl:if>
                  <xsl:if test="not(configured)">
                    <xsl:attribute name="class">disabled</xsl:attribute>
                  </xsl:if>
                  <xsl:if test="type='choice'">
                    <select class="inline" onkeydown="inLineKeyDown(event, this);" name="TODOgenInputChoice" style="visibility: visible;">
                      <xsl:if test="not(executable)">
                        <xsl:attribute name="onblur">inLineOnBlur(this);setValue(this);</xsl:attribute>
                      </xsl:if>
                      <xsl:if test="executable">
                        <xsl:attribute name="onblur">inLineOnBlur(this,'normal');</xsl:attribute>
                      </xsl:if>
                      <xsl:for-each select="arguments">
                        <option value="up">
                          <xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
                           <xsl:if test="../value = .">
                             <xsl:attribute name="selected">true</xsl:attribute>
                           </xsl:if>
                          <xsl:value-of select="."/>
                        </option>
                      </xsl:for-each>
                    </select>
                  </xsl:if>
                  <xsl:if test="not(type='choice')">
                    <input class="inline" type="text" onkeydown="inLineKeyDown(event, this);">
                      <xsl:if test="not(executable)">
                        <xsl:attribute name="onblur">inLineOnBlur(this);setValue(this);</xsl:attribute>
                      </xsl:if>
                      <xsl:if test="executable">
                        <xsl:attribute name="onblur">inLineOnBlur(this,'normal');</xsl:attribute>
                      </xsl:if>
                      <xsl:attribute name="value"><xsl:value-of select="value"/></xsl:attribute>
                    </input>
                  </xsl:if>
                  <input class="value" type="text" onkeydown="valueKeyDown(event, this)" ondblclick="startEdit(this); return false;" onmousedown='inLineLongTap(this); return false;' readonly="">
                    <xsl:attribute name="title"><xsl:text>header=[</xsl:text><xsl:value-of select="help"/><xsl:text>] body=[]</xsl:text></xsl:attribute>
                    <xsl:attribute name="value"><xsl:value-of select="value"/></xsl:attribute>
                    <xsl:attribute name="name"><xsl:value-of select="name"/></xsl:attribute>
                  </input>
                  <input class="lastvalue" type="hidden">
                    <xsl:attribute name="value"><xsl:value-of select="value"/></xsl:attribute>
                  </input>
                  <input class="defvalue" type="hidden">
                    <xsl:attribute name="value"><xsl:value-of select="defvalue"/></xsl:attribute>
                  </input>
                  <input class="stype" type="hidden">
                    <xsl:attribute name="value"><xsl:value-of select="type"/></xsl:attribute>
                  </input>
                  <xsl:if test="dependence">
                    <input class="dep" type="hidden" ><xsl:attribute name="value"><xsl:value-of select="dependence"/></xsl:attribute>
                    </input>
                  </xsl:if>
                </span>
              </xsl:if>
            </td>
            <td class="itemcontrols">
              <xsl:if test="executable">
                <img class="bexec" title="header=[webBtnRun] body=[]" alt="Execute" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);">
                  <xsl:attribute name="onclick">
                    <xsl:text>return executeTask(this,</xsl:text>
                    <xsl:if test="interactive">
                      'interactive'
                    </xsl:if>
                    <xsl:if test="not(interactive)">
                      ''
                    </xsl:if>
                    <xsl:text>);</xsl:text>
                  </xsl:attribute>
                </img>
              </xsl:if>
              <xsl:if test="not(type='directory') and configured">
                <img class="bdisable" onclick="return setNil(this);" title="header=[webBtnDisable] body=[]" alt="Disable" src="/nil.png" tabindex="0" onkeydown="return btnKeyDown(event,this);" />
              </xsl:if>
            </td>
          </tr>
        </tbody>
      </table>
      <div class="dir">
        <xsl:call-template name="DIR"/>
      </div>
    </li>
  </xsl:template>

  <xsl:template match="/LOGINPAGE">
    <html>
      <head>
        <title><xsl:text>NSG Web Configuration Manager</xsl:text></title>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
        <link rel="stylesheet" type="text/css" href="/style.css" />
        <link rel="icon" type="image/x-icon" href="/nsg.ico" />
        <link rel="shortcut icon" type="image/x-icon" href="/nsg.ico" />
      </head>
      <body class="login">
        <xsl:if test="error">
          <xsl:text>Message:</xsl:text><br/>
          <pre>
            <xsl:value-of select="error"/>
          </pre>
        </xsl:if>
        <div class="login">
          <center>
            <form id="loginform" class="login" method="post" enctype="application/x-www-form-urlencoded">
              <xsl:attribute name="onsubmit">
                var loginform=document.getElementById('loginform'); if(loginform) loginform.onsubmit = function(){ return false;};
              </xsl:attribute>
              <table class="login">
                <tbody>
                  <tr height="40%">
                    <td class="bottomcenter">
                      <img src="/nsg_logo.png" /><br/><xsl:text>NSG605F</xsl:text>
                      <br/><xsl:text>nsg</xsl:text>
                    </td>
                  </tr>
                  <tr height="35"><td class="lcenter"><xsl:text>Name:</xsl:text><input type="text" name="login" /><font color="#6699cc" ><xsl:text>:emaN</xsl:text></font></td></tr>
                  <tr height="35"><td class="lcenter"><xsl:text>Password:</xsl:text><input type="password" name="pass" /><font color="#6699cc" ><xsl:text>:drowssaP</xsl:text></font></td></tr>
                  <tr><td class="topcenter">
                    <input type="submit" name="submit" value="Login" />
                    <input type="hidden" name="command" value="start" />
                    <input type="hidden" name="timeout" value="60" />
                  </td></tr>
                </tbody>
              </table>
            </form>
          </center>
        </div>
      </body>
    </html>
  </xsl:template>
  
</xsl:stylesheet>

